#include "ti86asm.inc"
#include "asm86.h"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Matrix Code",0

ProgStart:
	call _clrScrn
	call _homeup
	call _flushallmenus
	call _runindicoff

FadeBlinds:
 push hl					;save all registers
 push de					;"
 push bc					;"
 push af					;"
 xor a						;A = 0
 ld b,8						;B = 8
BlindsLoop:
 scf						;set the carry flag
 rra						;rotate A right
 push bc					;save counter
 ld hl,$fc00				;HL = $FC00, start of graph memory
 ld (hl),a					;put A into first byte of graph memory
 ld de,$fc01				;DE = $FC01, second byte of graph memory
 ld bc,1023					;copy 1023 bytes (first byte is already set)
 ldir						;copy it
 ld b,6						;B = 6
BHaltLoop:
 halt						;stall calculator
 djnz BHaltLoop				;B = B - 1; if B != 0, go to BHaltLoop
 pop bc						;restore counter
 djnz BlindsLoop			;B = B - 1; if B != 0, go to BHaltLoop
 pop af						;restore registers
 pop bc						;"
 pop de						;"
 pop hl						;"

Prog:
	ld hl,AA
	call _puts
	call _getky
	cp K_NOKEY
	jp nz,EXIT
	jp Prog

AA:
 .db ""

EXIT:
	call _clrScrn
	call _homeup
	ld hl,TEXT
	xor a
	ld (_penRow),a
	ld (_penCol),a
	call _vputs
	ret

TEXT:
	.db "Really Bored Productions",0

.end
.end
